-- Global constants and variables for XPMC

global constant	TARGET_UNKNOWN = 0,
		TARGET_SMS = 1,
		TARGET_NES = 2,
		TARGET_GBA = 3,
		TARGET_NDS = 4,
		TARGET_GBC = 5,
		TARGET_SMD = 6,
		TARGET_SAT = 7,
		TARGET_XGS = 8,
		TARGET_SGG = 9

global constant	CMD_NOTE   = #00,
                CMD_REST   = #0C,
                CMD_OCTAVE = #10,
		CMD_DUTY   = #20,
		CMD_VOL2   = #30,
		CMD_OCTUP  = #40,
		CMD_OCTDN  = #50,
		CMD_VOLOUP = #60,
		CMD_VOLODN = #70,
		CMD_ARP2   = #80,
		CMD_ARPOFF = #90,
		CMD_MODE   = #A0,
		CMD_FEEDBK = #B0,
		CMD_OPER   = #C0,
		CMD_RSCALE = #D0,
		CMD_CBOFF  = #E0,
		CMD_CBONCE = #E1,
		CMD_CBEVNT = #E2,
		CMD_CBEVVC = #E3,
		CMD_CBEVVM = #E4,
		CMD_CBEVOC = #E5,
		CMD_CBNOTE = #E6,
		CMD_HWTE   = #E8,
		CMD_HWVE   = #E9,
		CMD_HWAM   = #EA,
		CMD_MODMAC = #EB,
		CMD_LDWAVE = #EC,
		CMD_DETUNE = #ED,
		CMD_ADSR   = #EE,
		CMD_MULT   = #EF,
		CMD_VOLSET = #F0,
		CMD_VOLMAC = #F1,
		CMD_DUTMAC = #F2,
		CMD_PORMAC = #F3,
		CMD_PANMAC = #F4,
		CMD_VIBMAC = #F5,
		CMD_SWPMAC = #F6,
		CMD_VSLMAC = #F7,
		CMD_ARPMAC = #F8,
		CMD_JMP    = #F9,
		CMD_DJNZ   = #FA,
		CMD_LOPCNT = #FB,
		CMD_APMAC2 = #FC,
		CMD_END	   = #FF
		
global constant	NOTES = {'c', -2, 'd', -2, 'e', 'f', -2, 'g', -2, 'a', -2, 'b', 'r'}

-- Octave 1 frequencies
global constant	OCTAVE1 =
{
	32.7032,	-- C
	34.6479,	-- C+ / D-
	36.7081,	-- D
	38.8909,	-- D+ / E-
	41.2035,	-- E
	43.6536,	-- F
	46.2493,	-- F+ / G-
	48.9995,	-- G
	51.9130,	-- G+ / A-
	55.0000,	-- A
	58.2705,	-- A+ / B-
	61.7354		-- B
}

-- Alternative frequencies for the SEGA Master System PSG
global constant	OCTAVE1_ALT_SMS = OCTAVE1 * 0.99370454545454545454545454545455


global constant	SUPPORTED_LENGTHS = {32, 16, 8, 4, 2, 1}


global constant	DIGITS = "0123456789",
		ALPHABET = "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
		ALPHANUM = DIGITS & ALPHABET & lower(ALPHABET),
		ALPHANUM2 = ALPHANUM & '@'

global constant	MONTHS = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}
global constant	WEEKDAYS = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"}

global constant CRLF = {13, 10}


global atom	updateFreq

global integer 	target,
		verbose,
		warningsAreErrors,
		fileDataPos,
		inFile,
		outFile,
		lineNum,
		songNum,
		maxTempo,
		minVolume,
		maxWavLength,
		maxWavSample,
		minWavSample,
		supportsPan,		-- Target supports some form of panning (@CS)
		supportsPAL,		-- Target has a 50 Hz video mode
		octaveRev,
		enRev,
		rest,
		adsrLen,		
		adsrMax,
		maxLoopDepth,
		tune,
		useFractionalDelays	-- Use fixed-point note lengths with fractional part (allows for
					-- finer granularity is tempo settings).
		

global sequence cmdLine,
		fileData,
		restOfLine,
		shortFilename,
		supportedChannels,	-- Channel names supported on the target
		songTitle,
		songComposer,
		songProgrammer,
		activeChannels,		-- Currently active channels
		supportsDutyChange,	-- Channel supports variable duty cycles
		supportsVolumeChange,	-- Channel volume can be changed (not just be set too on/off)
		supportsPCM,		-- Fixed frequency, samples tied to specific notes
		supportsWave,		-- Variable frequency
		supportsHwToneEnv,
		supportsHwVolEnv,
		supportsDetune,
		supportsFM,		-- Channel is an FM channel (YM2413, YM2612)
		maxVolume,
		machineVolLimit,
		minNote,
		minOctave,
		maxOctave,
		macros,
		loopStack,
		volumeMacros,
		panMacros,
		dutyMacros,
		pitchMacros,
		arpeggios,
		vibratos,
		portamentos,
		volumeSlides,
		callbacks,
		waveforms,
		tuple,
		pcms,
		adsrs,
		mods,
		usesEN,
		currentLength,
		currentOctave,
		currentTempo,
		currentCutoff,
		currentNote,
		currentVolume,
		loopPoint,
		lastSetLength,
		pendingOctChange,
		songs,
		songLen,
		songLoopLen,
		hasAnyNote,
		defines
		